﻿package tests {
	
	import flash.geom.Point;
	import com.gskinner.performance.TestSuite;
	import com.gskinner.performance.MethodTest;
	
	public class StrongTyping extends TestSuite {
		
	// Constants:
		
	// Public Properties:
		// the number of elements in each collection:
		public var loops:uint = 100000;
		
	// Protected Properties:
		// set up some variables used in the test:
		
	// Initialization:
		public function StrongTyping() {
			name = "StrongTyping";
			description = "Demonstrates impact of strong typing. "+loops+" loops.";
			tareTest = new MethodTest(tare);
			iterations = 4;
			tests = [
				new MethodTest(pointTyped, null, "pointTyped", 0, 1, "typed Point"),
				new MethodTest(pointUntyped, null, "pointUntyped", 0, 1, "untyped Point"),
				new MethodTest(objectTyped, null, "objectTyped", 0, 1, "typed Object"),
				new MethodTest(objectUntyped, null, "objectUntyped", 0, 1, "untyped Object")
			];
		}
		
	// Public getter / setters:
		
	// Public Methods:
		
	// Protected Methods:
		// tare method that will be run to calculate the base time required to run the loop
		// so it can be subtracted from the other test results.
		protected function tare():void {
			for (var i:uint=0; i<loops; i++) {
				
			}
		}
		
		protected function pointTyped():void {
			for (var i:uint=0; i<loops; i++) {
				var pt:Point = new Point(i,i/3);
				pt.x += i;
				pt.y -= i/2;
			}
		}
		
		protected function pointUntyped():void {
			for (var i:uint=0; i<loops; i++) {
				var pt:* = new Point(i,i/3);
				pt.x += i;
				pt.y -= i/2;
			}
		}
		
		protected function objectTyped():void {
			for (var i:uint=0; i<loops; i++) {
				var pt:Object = {x:i,y:i/3};
				pt.x += i;
				pt.y -= i/2;
			}
		}
		
		protected function objectUntyped():void {
			for (var i:uint=0; i<loops; i++) {
				var pt:* = {x:i,y:i/3};
				pt.x += i;
				pt.y -= i/2;
			}
		}
	
		
	}
	
}